using System;
using System.ServiceModel;

namespace WcfRestPox.Delicious
{
	[ServiceContract(Namespace = null)]
	[XmlSerializerFormat]
	interface IDeliciousService
	{
		[OperationContract(Action = "/v1/posts/update")]
		UpdateResponse GetLastUpdate();

		[OperationContract(Action = "/v1/tags/get")]
		TagsResponse GetAllTags();

		[OperationContract(Action = "/v1/tags/rename")]
		ResultResponse RenameTag(string old, string @new);
		
		[OperationContract(Action = "/v1/posts/get")]
		PostsResponse GetPosts(string tag, DateTime? dt, string url);

		[OperationContract(Action = "/v1/posts/recent")]
		PostsResponse GetRecentPosts(string tag, int? count);

		[OperationContract(Action = "/v1/posts/all")]
		PostsResponse GetAllPosts(string tag);

		[OperationContract(Action = "/v1/posts/dates")]
		DatesResponse GetDates(string tag);

		[OperationContract(Action = "/v1/posts/add")]
		ResultResponse AddPost(string url, string description, string extended, string[] tags);

		[OperationContract(Action = "/v1/posts/delete")]
		ResultResponse DeletePost(string url);

		[OperationContract(Action = "/v1/tags/bundles/all")]
		BundlesResponse GetAllBundles();

		[OperationContract(Action = "/v1/tags/bundles/set")]
		ResultResponse SetBundle(string bundle, string[] tags);

		[OperationContract(Action = "/v1/tags/bundles/delete")]
		ResultResponse DeleteBundle(string bundle);
	}
}
