using System.ServiceModel;
using System.Threading;
using WcfRestPox.Delicious;

namespace WcfRestPox
{
	class Program
	{
		static void Main()
		{
			ChannelFactory<IDeliciousService> factory = new ChannelFactory<IDeliciousService>("*");
			factory.Endpoint.Behaviors.Add(new RestPoxBehavior());
			factory.Credentials.UserName.UserName = "your del.icio.us username";
			factory.Credentials.UserName.Password = "your del.icio.us password";
			IDeliciousService rest = factory.CreateChannel();

			UpdateResponse updateResponse = rest.GetLastUpdate();
			Thread.Sleep(1000);

			TagsResponse tagsResponse = rest.GetAllTags();
			Thread.Sleep(1000);

			PostsResponse allPostsResponse = rest.GetAllPosts(null);
			Thread.Sleep(1000);

			ResultResponse renameResponse = rest.RenameTag("personal", "business");
			Thread.Sleep(1000);

			PostsResponse postsResponse = rest.GetPosts("business", null, null);
			Thread.Sleep(1000);

			PostsResponse recentPostsResponse = rest.GetRecentPosts(null, 5);
			Thread.Sleep(1000);

			DatesResponse datesResponse = rest.GetDates(null);
			Thread.Sleep(1000);

			ResultResponse addResponse = rest.AddPost("http://www.google.com/", "The best search engine", null, new string[] {"internet", "search"});
			Thread.Sleep(1000);

			ResultResponse deleteResponse = rest.DeletePost("http://www.google.com/");
			Thread.Sleep(1000);

			ResultResponse setBundleResponse = rest.SetBundle("inet", new string[] {"internet", "network", "web"});
			Thread.Sleep(1000);

			BundlesResponse bundlesResponse = rest.GetAllBundles();
			Thread.Sleep(1000);

			ResultResponse deleteBundleResponse = rest.DeleteBundle("inet");
			Thread.Sleep(1000);
		}
	}
}
